
#include "MacroPatternMatch.h"

#include "HROOTCoreTArray.h"

#include "TArrayL64.h"

#include "HROOTCoreTArrayL64.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TARRAY_DEF_VIRT(TArrayL64)
DELETABLE_DEF_VIRT(TArrayL64)
TARRAYL64_DEF_VIRT(TArrayL64)
TARRAYL64_DEF_NONVIRT(TArrayL64)
TARRAYL64_DEF_ACCESSOR(TArrayL64)

