
#include "MacroPatternMatch.h"

#include "HROOTCoreTVirtualMutex.h"

#include "TMutex.h"

#include "HROOTCoreTMutex.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TVIRTUALMUTEX_DEF_VIRT(TMutex)
DELETABLE_DEF_VIRT(TMutex)
TMUTEX_DEF_VIRT(TMutex)
TMUTEX_DEF_NONVIRT(TMutex)
TMUTEX_DEF_ACCESSOR(TMutex)

