{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.Rectangle_t.Interface where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Core.Rectangle_t.RawType
import STD.Deletable.Interface

class (IDeletable a) => IRectangle_t a where

upcastRectangle_t ::
                  forall a . (FPtr a, IRectangle_t a) => a -> Rectangle_t
upcastRectangle_t h
  = let fh = get_fptr h
        fh2 :: Ptr RawRectangle_t = castPtr fh
      in cast_fptr_to_obj fh2

downcastRectangle_t ::
                    forall a . (FPtr a, IRectangle_t a) => Rectangle_t -> a
downcastRectangle_t h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
