{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TArrayD.Interface where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Core.TArrayD.RawType
import HROOT.Core.TArray.Interface

class (ITArray a) => ITArrayD a where

upcastTArrayD :: forall a . (FPtr a, ITArrayD a) => a -> TArrayD
upcastTArrayD h
  = let fh = get_fptr h
        fh2 :: Ptr RawTArrayD = castPtr fh
      in cast_fptr_to_obj fh2

downcastTArrayD :: forall a . (FPtr a, ITArrayD a) => TArrayD -> a
downcastTArrayD h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
