{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module HROOT.Core.TArrayL.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import HROOT.Core.TArrayL.RawType
import HROOT.Core.TArrayL.RawType

foreign import ccall interruptible
               "HROOTCoreTArrayL.h TArrayL_GetAt" c_tarrayl_getat ::
               Ptr RawTArrayL -> CInt -> IO CDouble

foreign import ccall interruptible
               "HROOTCoreTArrayL.h TArrayL_SetArray" c_tarrayl_setarray ::
               Ptr RawTArrayL -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTArrayL.h TArrayL_SetAt" c_tarrayl_setat ::
               Ptr RawTArrayL -> CDouble -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTArrayL.h TArrayL_delete" c_tarrayl_delete ::
               Ptr RawTArrayL -> IO ()
