{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module HROOT.Core.TCollection.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import HROOT.Core.TCollection.RawType
import HROOT.Core.TCollection.FFI
import HROOT.Core.TCollection.Interface
import HROOT.Core.TCollection.Cast
import HROOT.Core.TCollection.RawType
import HROOT.Core.TCollection.Cast
import HROOT.Core.TCollection.Interface
import HROOT.Core.TClass.RawType
import HROOT.Core.TClass.Cast
import HROOT.Core.TClass.Interface
import HROOT.Core.TObject.RawType
import HROOT.Core.TObject.Cast
import HROOT.Core.TObject.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => ITCollection (TCollection) where

instance () => ITObject (TCollection) where
        clear = xform1 c_tcollection_clear
        draw = xform1 c_tcollection_draw
        findObject = xform1 c_tcollection_findobject
        getName = xform0 c_tcollection_getname
        isA = xform0 c_tcollection_isa
        paint = xform1 c_tcollection_paint
        printObj = xform1 c_tcollection_printobj
        saveAs = xform2 c_tcollection_saveas
        write = xform3 c_tcollection_write
        write_ = xform0 c_tcollection_write_

instance () => IDeletable (TCollection) where
        delete = xform0 c_tcollection_delete
