
#ifdef __cplusplus
extern "C" {
#endif

#pragma once


#include "HROOT-coreType.h"

#include "STDDeletable.h"

#include "stdcxxType.h"


#define TATTAXIS_DECL_VIRT(Type) \
int Type##_GetNdivisions ( Type##_p p );\
short Type##_GetAxisColor ( Type##_p p );\
short Type##_GetLabelColor ( Type##_p p );\
short Type##_GetLabelFont ( Type##_p p );\
float Type##_GetLabelOffset ( Type##_p p );\
float Type##_GetLabelSize ( Type##_p p );\
float Type##_GetTitleOffset ( Type##_p p );\
float Type##_GetTitleSize ( Type##_p p );\
float Type##_GetTickLength ( Type##_p p );\
short Type##_GetTitleFont ( Type##_p p );\
void Type##_SetNdivisions ( Type##_p p, int n, bool optim );\
void Type##_SetAxisColor ( Type##_p p, short color );\
void Type##_SetLabelColor ( Type##_p p, short color );\
void Type##_SetLabelFont ( Type##_p p, short font );\
void Type##_SetLabelOffset ( Type##_p p, float offset );\
void Type##_SetLabelSize ( Type##_p p, float size );\
void Type##_SetTickLength ( Type##_p p, float length );\
void Type##_SetTitleOffset ( Type##_p p, float offset );\
void Type##_SetTitleSize ( Type##_p p, float size );\
void Type##_SetTitleColor ( Type##_p p, short color );\
void Type##_SetTitleFont ( Type##_p p, short font );


#define TATTAXIS_DECL_NONVIRT(Type) \
Type##_p Type##_newTAttAxis (  );


#define TATTAXIS_DECL_ACCESSOR(Type) \



#define TATTAXIS_DEF_VIRT(Type) \
int Type##_GetNdivisions ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, GetNdivisions, TAttAxis))(p))->GetNdivisions();\
}\
\
short Type##_GetAxisColor ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, GetAxisColor, TAttAxis))(p))->GetAxisColor();\
}\
\
short Type##_GetLabelColor ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, GetLabelColor, TAttAxis))(p))->GetLabelColor();\
}\
\
short Type##_GetLabelFont ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, GetLabelFont, TAttAxis))(p))->GetLabelFont();\
}\
\
float Type##_GetLabelOffset ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, GetLabelOffset, TAttAxis))(p))->GetLabelOffset();\
}\
\
float Type##_GetLabelSize ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, GetLabelSize, TAttAxis))(p))->GetLabelSize();\
}\
\
float Type##_GetTitleOffset ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, GetTitleOffset, TAttAxis))(p))->GetTitleOffset();\
}\
\
float Type##_GetTitleSize ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, GetTitleSize, TAttAxis))(p))->GetTitleSize();\
}\
\
float Type##_GetTickLength ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, GetTickLength, TAttAxis))(p))->GetTickLength();\
}\
\
short Type##_GetTitleFont ( Type##_p p ) {\
return ((TYPECASTMETHOD(Type, GetTitleFont, TAttAxis))(p))->GetTitleFont();\
}\
\
void Type##_SetNdivisions ( Type##_p p, int n, bool optim ) {\
((TYPECASTMETHOD(Type, SetNdivisions, TAttAxis))(p))->SetNdivisions(n, optim);\
}\
\
void Type##_SetAxisColor ( Type##_p p, short color ) {\
((TYPECASTMETHOD(Type, SetAxisColor, TAttAxis))(p))->SetAxisColor(color);\
}\
\
void Type##_SetLabelColor ( Type##_p p, short color ) {\
((TYPECASTMETHOD(Type, SetLabelColor, TAttAxis))(p))->SetLabelColor(color);\
}\
\
void Type##_SetLabelFont ( Type##_p p, short font ) {\
((TYPECASTMETHOD(Type, SetLabelFont, TAttAxis))(p))->SetLabelFont(font);\
}\
\
void Type##_SetLabelOffset ( Type##_p p, float offset ) {\
((TYPECASTMETHOD(Type, SetLabelOffset, TAttAxis))(p))->SetLabelOffset(offset);\
}\
\
void Type##_SetLabelSize ( Type##_p p, float size ) {\
((TYPECASTMETHOD(Type, SetLabelSize, TAttAxis))(p))->SetLabelSize(size);\
}\
\
void Type##_SetTickLength ( Type##_p p, float length ) {\
((TYPECASTMETHOD(Type, SetTickLength, TAttAxis))(p))->SetTickLength(length);\
}\
\
void Type##_SetTitleOffset ( Type##_p p, float offset ) {\
((TYPECASTMETHOD(Type, SetTitleOffset, TAttAxis))(p))->SetTitleOffset(offset);\
}\
\
void Type##_SetTitleSize ( Type##_p p, float size ) {\
((TYPECASTMETHOD(Type, SetTitleSize, TAttAxis))(p))->SetTitleSize(size);\
}\
\
void Type##_SetTitleColor ( Type##_p p, short color ) {\
((TYPECASTMETHOD(Type, SetTitleColor, TAttAxis))(p))->SetTitleColor(color);\
}\
\
void Type##_SetTitleFont ( Type##_p p, short font ) {\
((TYPECASTMETHOD(Type, SetTitleFont, TAttAxis))(p))->SetTitleFont(font);\
}


#define TATTAXIS_DEF_NONVIRT(Type) \
Type##_p Type##_newTAttAxis (  ) {\
Type* newp=new Type();return from_nonconst_to_nonconst<Type##_t, Type>(newp);\
}


#define TATTAXIS_DEF_ACCESSOR(Type) \



DELETABLE_DECL_VIRT(TAttAxis)
TATTAXIS_DECL_VIRT(TAttAxis)
TATTAXIS_DECL_NONVIRT(TAttAxis)
TATTAXIS_DECL_ACCESSOR(TAttAxis)

#ifdef __cplusplus
}
#endif

