
#include "MacroPatternMatch.h"

#include "HROOTCoreRectangle_t.h"

#include "STDDeletable.h"

#include "TAttBBox2D.h"

#include "HROOTCoreTAttBBox2D.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

DELETABLE_DEF_VIRT(TAttBBox2D)
TATTBBOX2D_DEF_NONVIRT(TAttBBox2D)
TATTBBOX2D_DEF_ACCESSOR(TAttBBox2D)

