
#include "MacroPatternMatch.h"

#include "HROOTCoreTDictionary.h"

#include "TGlobal.h"

#include "HROOTCoreTGlobal.h"

using namespace ROOT;

#define CHECKPROTECT(x,y) FXIS_PAREN(IS_ ## x ## _ ## y ## _PROTECTED)

#define TYPECASTMETHOD(cname,mname,oname) \
  FXIIF( CHECKPROTECT(cname,mname) ) ( \
  (from_nonconst_to_nonconst<oname,cname ## _t>), \
  (from_nonconst_to_nonconst<cname,cname ## _t>) )

TDICTIONARY_DEF_VIRT(TGlobal)
TNAMED_DEF_VIRT(TGlobal)
TOBJECT_DEF_VIRT(TGlobal)
DELETABLE_DEF_VIRT(TGlobal)
TGLOBAL_DEF_VIRT(TGlobal)
TGLOBAL_DEF_NONVIRT(TGlobal)
TGLOBAL_DEF_ACCESSOR(TGlobal)

