{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module HROOT.Core.TArray.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import HROOT.Core.TArray.RawType
import HROOT.Core.TArray.RawType

foreign import ccall interruptible
               "HROOTCoreTArray.h TArray_delete" c_tarray_delete ::
               Ptr RawTArray -> IO ()

foreign import ccall interruptible "HROOTCoreTArray.h TArray_GetAt"
               c_tarray_getat :: Ptr RawTArray -> CInt -> IO CDouble

foreign import ccall interruptible
               "HROOTCoreTArray.h TArray_tArray_GetSize" c_tarray_tarray_getsize
               :: Ptr RawTArray -> IO CInt

foreign import ccall interruptible
               "HROOTCoreTArray.h TArray_SetArray" c_tarray_setarray ::
               Ptr RawTArray -> CInt -> IO ()

foreign import ccall interruptible "HROOTCoreTArray.h TArray_SetAt"
               c_tarray_setat :: Ptr RawTArray -> CDouble -> CInt -> IO ()
