{-# LANGUAGE ForeignFunctionInterface, InterruptibleFFI #-}
module HROOT.Core.TArrayC.FFI where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import HROOT.Core.TArrayC.RawType
import HROOT.Core.TArrayC.RawType

foreign import ccall interruptible
               "HROOTCoreTArrayC.h TArrayC_GetAt" c_tarrayc_getat ::
               Ptr RawTArrayC -> CInt -> IO CDouble

foreign import ccall interruptible
               "HROOTCoreTArrayC.h TArrayC_SetArray" c_tarrayc_setarray ::
               Ptr RawTArrayC -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTArrayC.h TArrayC_SetAt" c_tarrayc_setat ::
               Ptr RawTArrayC -> CDouble -> CInt -> IO ()

foreign import ccall interruptible
               "HROOTCoreTArrayC.h TArrayC_delete" c_tarrayc_delete ::
               Ptr RawTArrayC -> IO ()
