{-# LANGUAGE EmptyDataDecls, ExistentialQuantification,
  FlexibleContexts, FlexibleInstances, ForeignFunctionInterface,
  MultiParamTypeClasses, ScopedTypeVariables, TypeFamilies,
  TypeSynonymInstances #-}
module HROOT.Core.TAttBBox.Interface where
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import FFICXX.Runtime.Cast
import HROOT.Core.TAttBBox.RawType
import STD.Deletable.Interface

class (IDeletable a) => ITAttBBox a where

upcastTAttBBox :: forall a . (FPtr a, ITAttBBox a) => a -> TAttBBox
upcastTAttBBox h
  = let fh = get_fptr h
        fh2 :: Ptr RawTAttBBox = castPtr fh
      in cast_fptr_to_obj fh2

downcastTAttBBox ::
                 forall a . (FPtr a, ITAttBBox a) => TAttBBox -> a
downcastTAttBBox h
  = let fh = get_fptr h
        fh2 = castPtr fh
      in cast_fptr_to_obj fh2
