{-# LANGUAGE EmptyDataDecls, FlexibleContexts, FlexibleInstances,
  ForeignFunctionInterface, IncoherentInstances,
  MultiParamTypeClasses, OverlappingInstances, TemplateHaskell,
  TypeFamilies, TypeSynonymInstances #-}
module HROOT.Core.TAttCanvas.Implementation where
import Data.Monoid
import Data.Word
import Data.Int
import Foreign.C
import Foreign.Ptr
import Language.Haskell.TH
import Language.Haskell.TH.Syntax
import System.IO.Unsafe
import FFICXX.Runtime.Cast
import FFICXX.Runtime.CodeGen.Cxx
import FFICXX.Runtime.TH
import HROOT.Core.TAttCanvas.RawType
import HROOT.Core.TAttCanvas.FFI
import HROOT.Core.TAttCanvas.Interface
import HROOT.Core.TAttCanvas.Cast
import HROOT.Core.TAttCanvas.RawType
import HROOT.Core.TAttCanvas.Cast
import HROOT.Core.TAttCanvas.Interface
import STD.Deletable.RawType
import STD.Deletable.Cast
import STD.Deletable.Interface

instance () => ITAttCanvas (TAttCanvas) where

instance () => IDeletable (TAttCanvas) where
        delete = xform0 c_tattcanvas_delete

newTAttCanvas :: () => IO TAttCanvas
newTAttCanvas = xformnull c_tattcanvas_newtattcanvas
